
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Windows;
using System.Data;
using Oracle.DataAccess.Client;
using System.Threading;
using System.IO;
using System;
using System.Text;

namespace TGradebook_In_C_Sharp
{
	/// <summary>
	/// The class contains the class for one class, and its policy.
	/// </summary>
	public class FrmClassGrades : System.Windows.Forms.Form
	{
		#region Window Form Designer generated data members.

		private System.Windows.Forms.GroupBox gbCourseOffering;
		private System.Windows.Forms.MainMenu mnTGradebook;
		private System.Windows.Forms.DataGrid dgGrade;
		private System.Windows.Forms.ComboBox cmbYear;
		private System.Windows.Forms.MenuItem mitFile;
		private System.Windows.Forms.MenuItem mitStudent;
		private System.Windows.Forms.MenuItem mitClass;
		private System.Windows.Forms.MenuItem mitReport;
		private System.Windows.Forms.MenuItem mitSystem;
		private System.Windows.Forms.MenuItem mitHelp;
		private System.Windows.Forms.ComboBox cmbQuarter;
		private System.Windows.Forms.ComboBox cmbSection;
		private System.Windows.Forms.TextBox txtClassFilter;
		private System.Windows.Forms.GroupBox gbComments;
		private System.Windows.Forms.TextBox txtComments;
		private System.Windows.Forms.GroupBox gbGradingPolicy;
		private System.Windows.Forms.TextBox txtPCTHWK;
		private System.Windows.Forms.Label lbDropsHWK;
		private System.Windows.Forms.Label lbPCTHWK;
		private System.Windows.Forms.Label lbMaxHWK;
		private System.Windows.Forms.Label lbNoHWK;
		private System.Windows.Forms.TextBox txtPCTMidterm1;
		private System.Windows.Forms.Label lbPCTMidterm1;
		private System.Windows.Forms.Label lbMaxMidterm1;
		private System.Windows.Forms.TextBox txtPCTMidterm2;
		private System.Windows.Forms.Label lbPCTMidterm2;
		private System.Windows.Forms.Label lbMaxMidterm2;
		private System.Windows.Forms.TextBox txtPCTFinal;
		private System.Windows.Forms.Label lbPCTFinal;
		private System.Windows.Forms.Label lbMaxFinal;
		private System.Windows.Forms.Label lbEditableField;
		private System.Windows.Forms.ComboBox cmbEditableField;
		private System.Windows.Forms.MenuItem mitSaveToTextFile;
		private System.Windows.Forms.ImageList imgToolBar;
		private System.Windows.Forms.ToolBarButton tbbSepartor1;
		private System.Windows.Forms.ComboBox cmbCourseName;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.TextBox txtHWKDrops;
		private System.Windows.Forms.TextBox txtNumHWK;
		private System.Windows.Forms.TextBox txtMAXFinal;
		private System.Windows.Forms.TextBox txtMAXMidterm2;
		private System.Windows.Forms.TextBox txtMAXMidterm1;
		private System.Windows.Forms.TextBox txtMAXHWK;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.ToolBarButton toolBarButton4;
		private System.Windows.Forms.ToolBarButton tbbStudentsOrGrade;
		private System.Windows.Forms.ToolBarButton tbbAddStudent;
		private System.Windows.Forms.ToolBarButton tbbCalcToal;
		private System.Windows.Forms.ToolBarButton tbbNewClass;
		private System.Windows.Forms.ToolBarButton tbbPrintReport;
		private System.Windows.Forms.GroupBox gbStudentList;
		private System.Windows.Forms.RadioButton rdbActiveStudents;
		private System.Windows.Forms.TextBox txtStudentFilter;
		#endregion

		#region H. Wang - Defined data members

		int formOrigWidth = 0;
		int formOrigHeight = 0;
		int preEditableCol = 0;
		System.Data.DataTable dtPolicy = null;
		System.Data.DataTable dtGrade = null;
		System.Data.DataTable dtStudent = null;
		System.Data.DataSet ds = null;
		System.Windows.Forms.BindingManagerBase cm = null;		
		int curEditableCol = 6;
		private System.Windows.Forms.DataGrid dgStudent;
		private System.Windows.Forms.RadioButton rdbInactiveStudents;
		private System.Drawing.Size[] windowSize =
				new Size[] { new Size(742, 760), new Size(480, 648), new Size(376, 134)};
		private string strActiveOrInactive = "Active";
		private System.Windows.Forms.ToolBarButton tbbRemoveStudentFromList;
		private System.Windows.Forms.ToolBarButton tbbSaveAll;
		private System.Windows.Forms.MenuItem mitFTP;
		private System.Windows.Forms.MenuItem mitReloadData;
		private System.Windows.Forms.MenuItem mitExit;
		private System.Windows.Forms.MenuItem mitAddStudent;
		private System.Windows.Forms.MenuItem mitShowAllGrades;
		private System.Windows.Forms.MenuItem mitRemoveStudent;
		private System.Windows.Forms.MenuItem mitAddClass;
		private System.Windows.Forms.MenuItem mitRemoveClass;
		private System.Windows.Forms.MenuItem mitGradeReport;
		private System.Windows.Forms.MenuItem mitClassTrack;
		private System.Windows.Forms.MenuItem mitChangePassword;
		private System.Windows.Forms.MenuItem mitSetFTPPath;
		private System.Windows.Forms.MenuItem mitAbout;
		private System.Windows.Forms.MenuItem mitReadFile;
		private System.Windows.Forms.ToolBar toolbarTGradebook;
		private System.Windows.Forms.Button btnAddNewCourse;
		private System.Windows.Forms.Button btnCancellNewCourse;
		private System.Windows.Forms.Label lbChangeStatus;
		private System.Windows.Forms.Label lbAddStudentToClass;
		private System.Windows.Forms.MenuItem mitChangeStudentID;
        private ComboBox cmbMajors;
		private string strCurrentClass = null;
		#endregion

		#region FrmClassGrades Constructors
		public FrmClassGrades()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		#endregion

		#region Windows Form Designer generated code

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FrmClassGrades));
            this.dgGrade = new System.Windows.Forms.DataGrid();
            this.gbCourseOffering = new System.Windows.Forms.GroupBox();
            this.btnCancellNewCourse = new System.Windows.Forms.Button();
            this.btnAddNewCourse = new System.Windows.Forms.Button();
            this.txtClassFilter = new System.Windows.Forms.TextBox();
            this.cmbSection = new System.Windows.Forms.ComboBox();
            this.cmbCourseName = new System.Windows.Forms.ComboBox();
            this.cmbQuarter = new System.Windows.Forms.ComboBox();
            this.cmbYear = new System.Windows.Forms.ComboBox();
            this.mnTGradebook = new System.Windows.Forms.MainMenu(this.components);
            this.mitFile = new System.Windows.Forms.MenuItem();
            this.mitSaveToTextFile = new System.Windows.Forms.MenuItem();
            this.mitReadFile = new System.Windows.Forms.MenuItem();
            this.mitFTP = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.mitReloadData = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.mitExit = new System.Windows.Forms.MenuItem();
            this.mitStudent = new System.Windows.Forms.MenuItem();
            this.mitAddStudent = new System.Windows.Forms.MenuItem();
            this.mitShowAllGrades = new System.Windows.Forms.MenuItem();
            this.mitRemoveStudent = new System.Windows.Forms.MenuItem();
            this.mitChangeStudentID = new System.Windows.Forms.MenuItem();
            this.mitClass = new System.Windows.Forms.MenuItem();
            this.mitAddClass = new System.Windows.Forms.MenuItem();
            this.mitRemoveClass = new System.Windows.Forms.MenuItem();
            this.mitReport = new System.Windows.Forms.MenuItem();
            this.mitGradeReport = new System.Windows.Forms.MenuItem();
            this.mitClassTrack = new System.Windows.Forms.MenuItem();
            this.mitSystem = new System.Windows.Forms.MenuItem();
            this.mitChangePassword = new System.Windows.Forms.MenuItem();
            this.mitSetFTPPath = new System.Windows.Forms.MenuItem();
            this.mitHelp = new System.Windows.Forms.MenuItem();
            this.mitAbout = new System.Windows.Forms.MenuItem();
            this.toolbarTGradebook = new System.Windows.Forms.ToolBar();
            this.tbbAddStudent = new System.Windows.Forms.ToolBarButton();
            this.tbbRemoveStudentFromList = new System.Windows.Forms.ToolBarButton();
            this.tbbSepartor1 = new System.Windows.Forms.ToolBarButton();
            this.tbbCalcToal = new System.Windows.Forms.ToolBarButton();
            this.tbbNewClass = new System.Windows.Forms.ToolBarButton();
            this.tbbPrintReport = new System.Windows.Forms.ToolBarButton();
            this.toolBarButton4 = new System.Windows.Forms.ToolBarButton();
            this.tbbSaveAll = new System.Windows.Forms.ToolBarButton();
            this.tbbStudentsOrGrade = new System.Windows.Forms.ToolBarButton();
            this.imgToolBar = new System.Windows.Forms.ImageList(this.components);
            this.gbComments = new System.Windows.Forms.GroupBox();
            this.txtComments = new System.Windows.Forms.TextBox();
            this.gbGradingPolicy = new System.Windows.Forms.GroupBox();
            this.cmbEditableField = new System.Windows.Forms.ComboBox();
            this.lbEditableField = new System.Windows.Forms.Label();
            this.txtPCTFinal = new System.Windows.Forms.TextBox();
            this.txtMAXFinal = new System.Windows.Forms.TextBox();
            this.lbPCTFinal = new System.Windows.Forms.Label();
            this.lbMaxFinal = new System.Windows.Forms.Label();
            this.txtPCTMidterm2 = new System.Windows.Forms.TextBox();
            this.txtMAXMidterm2 = new System.Windows.Forms.TextBox();
            this.lbPCTMidterm2 = new System.Windows.Forms.Label();
            this.lbMaxMidterm2 = new System.Windows.Forms.Label();
            this.txtPCTMidterm1 = new System.Windows.Forms.TextBox();
            this.txtMAXMidterm1 = new System.Windows.Forms.TextBox();
            this.lbPCTMidterm1 = new System.Windows.Forms.Label();
            this.lbMaxMidterm1 = new System.Windows.Forms.Label();
            this.txtHWKDrops = new System.Windows.Forms.TextBox();
            this.txtPCTHWK = new System.Windows.Forms.TextBox();
            this.txtMAXHWK = new System.Windows.Forms.TextBox();
            this.txtNumHWK = new System.Windows.Forms.TextBox();
            this.lbDropsHWK = new System.Windows.Forms.Label();
            this.lbPCTHWK = new System.Windows.Forms.Label();
            this.lbMaxHWK = new System.Windows.Forms.Label();
            this.lbNoHWK = new System.Windows.Forms.Label();
            this.gbStudentList = new System.Windows.Forms.GroupBox();
            this.cmbMajors = new System.Windows.Forms.ComboBox();
            this.lbAddStudentToClass = new System.Windows.Forms.Label();
            this.lbChangeStatus = new System.Windows.Forms.Label();
            this.txtStudentFilter = new System.Windows.Forms.TextBox();
            this.rdbInactiveStudents = new System.Windows.Forms.RadioButton();
            this.rdbActiveStudents = new System.Windows.Forms.RadioButton();
            this.dgStudent = new System.Windows.Forms.DataGrid();
            ((System.ComponentModel.ISupportInitialize)(this.dgGrade)).BeginInit();
            this.gbCourseOffering.SuspendLayout();
            this.gbComments.SuspendLayout();
            this.gbGradingPolicy.SuspendLayout();
            this.gbStudentList.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.dgStudent)).BeginInit();
            this.SuspendLayout();
            // 
            // dgGrade
            // 
            this.dgGrade.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.dgGrade.CaptionText = "Click Right Mouse Button to Remove a Student from a Class.";
            this.dgGrade.DataMember = "";
            this.dgGrade.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.dgGrade.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dgGrade.Location = new System.Drawing.Point(8, 152);
            this.dgGrade.Name = "dgGrade";
            this.dgGrade.Size = new System.Drawing.Size(718, 478);
            this.dgGrade.TabIndex = 0;
            this.dgGrade.Navigate += new System.Windows.Forms.NavigateEventHandler(this.dgGrade_Navigate);
            // 
            // gbCourseOffering
            // 
            this.gbCourseOffering.Controls.Add(this.btnCancellNewCourse);
            this.gbCourseOffering.Controls.Add(this.btnAddNewCourse);
            this.gbCourseOffering.Controls.Add(this.txtClassFilter);
            this.gbCourseOffering.Controls.Add(this.cmbSection);
            this.gbCourseOffering.Controls.Add(this.cmbCourseName);
            this.gbCourseOffering.Controls.Add(this.cmbQuarter);
            this.gbCourseOffering.Controls.Add(this.cmbYear);
            this.gbCourseOffering.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.gbCourseOffering.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.gbCourseOffering.Location = new System.Drawing.Point(4, 30);
            this.gbCourseOffering.Name = "gbCourseOffering";
            this.gbCourseOffering.Size = new System.Drawing.Size(362, 44);
            this.gbCourseOffering.TabIndex = 1;
            this.gbCourseOffering.TabStop = false;
            this.gbCourseOffering.Text = " Year      Quarter       Course Name   Sec.     Filtering";
            // 
            // btnCancellNewCourse
            // 
            this.btnCancellNewCourse.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnCancellNewCourse.Location = new System.Drawing.Point(306, 16);
            this.btnCancellNewCourse.Name = "btnCancellNewCourse";
            this.btnCancellNewCourse.Size = new System.Drawing.Size(50, 22);
            this.btnCancellNewCourse.TabIndex = 6;
            this.btnCancellNewCourse.Text = "Cancel";
            this.btnCancellNewCourse.Visible = false;
            // 
            // btnAddNewCourse
            // 
            this.btnAddNewCourse.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnAddNewCourse.Location = new System.Drawing.Point(264, 16);
            this.btnAddNewCourse.Name = "btnAddNewCourse";
            this.btnAddNewCourse.Size = new System.Drawing.Size(40, 22);
            this.btnAddNewCourse.TabIndex = 5;
            this.btnAddNewCourse.Text = "Add";
            this.btnAddNewCourse.Visible = false;
            // 
            // txtClassFilter
            // 
            this.txtClassFilter.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtClassFilter.Location = new System.Drawing.Point(264, 18);
            this.txtClassFilter.Name = "txtClassFilter";
            this.txtClassFilter.Size = new System.Drawing.Size(92, 21);
            this.txtClassFilter.TabIndex = 4;
            this.txtClassFilter.TextChanged += new System.EventHandler(this.txtClassFilter_TextChanged);
            // 
            // cmbSection
            // 
            this.cmbSection.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmbSection.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8"});
            this.cmbSection.Location = new System.Drawing.Point(224, 18);
            this.cmbSection.Name = "cmbSection";
            this.cmbSection.Size = new System.Drawing.Size(35, 21);
            this.cmbSection.TabIndex = 3;
            this.cmbSection.Text = "1";
            // 
            // cmbCourseName
            // 
            this.cmbCourseName.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmbCourseName.Location = new System.Drawing.Point(140, 18);
            this.cmbCourseName.Name = "cmbCourseName";
            this.cmbCourseName.Size = new System.Drawing.Size(80, 21);
            this.cmbCourseName.TabIndex = 2;
            this.cmbCourseName.SelectedIndexChanged += new System.EventHandler(this.cmbCourseName_SelectedIndexChanged_1);
            // 
            // cmbQuarter
            // 
            this.cmbQuarter.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmbQuarter.Items.AddRange(new object[] {
            "FALL",
            "WINTER",
            "SPRING",
            "SUMMER 1",
            "SUMMER 2"});
            this.cmbQuarter.Location = new System.Drawing.Point(58, 18);
            this.cmbQuarter.Name = "cmbQuarter";
            this.cmbQuarter.Size = new System.Drawing.Size(80, 21);
            this.cmbQuarter.TabIndex = 1;
            this.cmbQuarter.Text = "FALL";
            this.cmbQuarter.SelectedIndexChanged += new System.EventHandler(this.cmbQuarter_SelectedIndexChanged_1);
            // 
            // cmbYear
            // 
            this.cmbYear.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmbYear.Location = new System.Drawing.Point(5, 18);
            this.cmbYear.Name = "cmbYear";
            this.cmbYear.Size = new System.Drawing.Size(50, 21);
            this.cmbYear.TabIndex = 0;
            // 
            // mnTGradebook
            // 
            this.mnTGradebook.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mitFile,
            this.mitStudent,
            this.mitClass,
            this.mitReport,
            this.mitSystem,
            this.mitHelp});
            // 
            // mitFile
            // 
            this.mitFile.Index = 0;
            this.mitFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mitSaveToTextFile,
            this.mitReadFile,
            this.mitFTP,
            this.menuItem2,
            this.mitReloadData,
            this.menuItem4,
            this.mitExit});
            this.mitFile.Text = "File";
            this.mitFile.Click += new System.EventHandler(this.mitFile_Click);
            // 
            // mitSaveToTextFile
            // 
            this.mitSaveToTextFile.Index = 0;
            this.mitSaveToTextFile.Text = "Save to Text File";
            this.mitSaveToTextFile.Click += new System.EventHandler(this.mitSaveToTextFile_Click);
            // 
            // mitReadFile
            // 
            this.mitReadFile.Index = 1;
            this.mitReadFile.Text = "Read a Text File";
            this.mitReadFile.Click += new System.EventHandler(this.mitReadFile_Click);
            // 
            // mitFTP
            // 
            this.mitFTP.Index = 2;
            this.mitFTP.Text = "Send File to Other Host";
            this.mitFTP.Click += new System.EventHandler(this.mitFTP_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 3;
            this.menuItem2.Text = "-";
            // 
            // mitReloadData
            // 
            this.mitReloadData.Index = 4;
            this.mitReloadData.Text = "Reload Data";
            this.mitReloadData.Click += new System.EventHandler(this.mitReloadData_Click);
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 5;
            this.menuItem4.Text = "-";
            // 
            // mitExit
            // 
            this.mitExit.Index = 6;
            this.mitExit.Text = "Exit";
            this.mitExit.Click += new System.EventHandler(this.mitExit_Click);
            // 
            // mitStudent
            // 
            this.mitStudent.Enabled = false;
            this.mitStudent.Index = 1;
            this.mitStudent.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mitAddStudent,
            this.mitShowAllGrades,
            this.mitRemoveStudent,
            this.mitChangeStudentID});
            this.mitStudent.Text = "Student";
            // 
            // mitAddStudent
            // 
            this.mitAddStudent.Index = 0;
            this.mitAddStudent.Text = "Add a Student to List and Current Class";
            this.mitAddStudent.Click += new System.EventHandler(this.mitAddStudent_Click);
            // 
            // mitShowAllGrades
            // 
            this.mitShowAllGrades.Index = 1;
            this.mitShowAllGrades.Text = "Show All Grades of Current Student";
            this.mitShowAllGrades.Click += new System.EventHandler(this.mitShowAllGrades_Click);
            // 
            // mitRemoveStudent
            // 
            this.mitRemoveStudent.Index = 2;
            this.mitRemoveStudent.Text = "Remove a student and all Grades";
            // 
            // mitChangeStudentID
            // 
            this.mitChangeStudentID.Index = 3;
            this.mitChangeStudentID.Text = "Change student ID";
            this.mitChangeStudentID.Click += new System.EventHandler(this.mitChangeStudentID_Click);
            // 
            // mitClass
            // 
            this.mitClass.Index = 2;
            this.mitClass.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mitAddClass,
            this.mitRemoveClass});
            this.mitClass.Text = "Class";
            this.mitClass.Click += new System.EventHandler(this.mitClass_Click);
            // 
            // mitAddClass
            // 
            this.mitAddClass.Index = 0;
            this.mitAddClass.Text = "Add a New Class";
            this.mitAddClass.Click += new System.EventHandler(this.mitAddClass_Click);
            // 
            // mitRemoveClass
            // 
            this.mitRemoveClass.Index = 1;
            this.mitRemoveClass.Text = "Delete a Class with its Enrollments";
            this.mitRemoveClass.Click += new System.EventHandler(this.mitRemoveClass_Click);
            // 
            // mitReport
            // 
            this.mitReport.Index = 3;
            this.mitReport.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mitGradeReport,
            this.mitClassTrack});
            this.mitReport.Text = "Report";
            this.mitReport.Click += new System.EventHandler(this.mitReport_Click);
            // 
            // mitGradeReport
            // 
            this.mitGradeReport.Index = 0;
            this.mitGradeReport.Text = "Class Grade Report";
            this.mitGradeReport.Click += new System.EventHandler(this.mitGradeReport_Click);
            // 
            // mitClassTrack
            // 
            this.mitClassTrack.Index = 1;
            this.mitClassTrack.Text = "Class Track Report";
            this.mitClassTrack.Click += new System.EventHandler(this.mitClassTrack_Click);
            // 
            // mitSystem
            // 
            this.mitSystem.Index = 4;
            this.mitSystem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mitChangePassword,
            this.mitSetFTPPath});
            this.mitSystem.Text = "System";
            // 
            // mitChangePassword
            // 
            this.mitChangePassword.Index = 0;
            this.mitChangePassword.Text = "Change Password";
            // 
            // mitSetFTPPath
            // 
            this.mitSetFTPPath.Index = 1;
            this.mitSetFTPPath.Text = "Reset FTP Program Path";
            // 
            // mitHelp
            // 
            this.mitHelp.Index = 5;
            this.mitHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mitAbout});
            this.mitHelp.Text = "Help";
            this.mitHelp.Click += new System.EventHandler(this.mitHelp_Click);
            // 
            // mitAbout
            // 
            this.mitAbout.Index = 0;
            this.mitAbout.Text = "About ...";
            // 
            // toolbarTGradebook
            // 
            this.toolbarTGradebook.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
            this.toolbarTGradebook.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.toolbarTGradebook.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.tbbAddStudent,
            this.tbbRemoveStudentFromList,
            this.tbbSepartor1,
            this.tbbCalcToal,
            this.tbbNewClass,
            this.tbbPrintReport,
            this.toolBarButton4,
            this.tbbSaveAll,
            this.tbbStudentsOrGrade});
            this.toolbarTGradebook.ButtonSize = new System.Drawing.Size(20, 20);
            this.toolbarTGradebook.DropDownArrows = true;
            this.toolbarTGradebook.ImageList = this.imgToolBar;
            this.toolbarTGradebook.Location = new System.Drawing.Point(0, 0);
            this.toolbarTGradebook.Name = "toolbarTGradebook";
            this.toolbarTGradebook.ShowToolTips = true;
            this.toolbarTGradebook.Size = new System.Drawing.Size(734, 29);
            this.toolbarTGradebook.TabIndex = 2;
            this.toolbarTGradebook.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolbar_ButtonClick);
            // 
            // tbbAddStudent
            // 
            this.tbbAddStudent.Enabled = false;
            this.tbbAddStudent.ImageIndex = 0;
            this.tbbAddStudent.Name = "tbbAddStudent";
            this.tbbAddStudent.Tag = "addNewStudent";
            this.tbbAddStudent.ToolTipText = "Add a new student to list";
            // 
            // tbbRemoveStudentFromList
            // 
            this.tbbRemoveStudentFromList.Enabled = false;
            this.tbbRemoveStudentFromList.ImageIndex = 1;
            this.tbbRemoveStudentFromList.Name = "tbbRemoveStudentFromList";
            this.tbbRemoveStudentFromList.Tag = "removeStudentFromList";
            this.tbbRemoveStudentFromList.ToolTipText = "Remove current student from list and class(es)";
            // 
            // tbbSepartor1
            // 
            this.tbbSepartor1.Enabled = false;
            this.tbbSepartor1.Name = "tbbSepartor1";
            this.tbbSepartor1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // tbbCalcToal
            // 
            this.tbbCalcToal.ImageIndex = 3;
            this.tbbCalcToal.Name = "tbbCalcToal";
            this.tbbCalcToal.Tag = "calcTotal";
            this.tbbCalcToal.ToolTipText = "Calculate total and ranking";
            // 
            // tbbNewClass
            // 
            this.tbbNewClass.ImageIndex = 6;
            this.tbbNewClass.Name = "tbbNewClass";
            this.tbbNewClass.Tag = "addNewClass";
            this.tbbNewClass.ToolTipText = "Create a new class";
            // 
            // tbbPrintReport
            // 
            this.tbbPrintReport.ImageIndex = 7;
            this.tbbPrintReport.Name = "tbbPrintReport";
            this.tbbPrintReport.Tag = "printReport";
            this.tbbPrintReport.ToolTipText = "Print a class report";
            // 
            // toolBarButton4
            // 
            this.toolBarButton4.Name = "toolBarButton4";
            this.toolBarButton4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // tbbSaveAll
            // 
            this.tbbSaveAll.ImageIndex = 4;
            this.tbbSaveAll.Name = "tbbSaveAll";
            this.tbbSaveAll.Tag = "saveAll";
            this.tbbSaveAll.ToolTipText = "Save all changes";
            // 
            // tbbStudentsOrGrade
            // 
            this.tbbStudentsOrGrade.ImageIndex = 8;
            this.tbbStudentsOrGrade.Name = "tbbStudentsOrGrade";
            this.tbbStudentsOrGrade.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
            this.tbbStudentsOrGrade.Tag = "showStudents";
            this.tbbStudentsOrGrade.ToolTipText = "Display student list page";
            // 
            // imgToolBar
            // 
            this.imgToolBar.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgToolBar.ImageStream")));
            this.imgToolBar.TransparentColor = System.Drawing.Color.Transparent;
            this.imgToolBar.Images.SetKeyName(0, "");
            this.imgToolBar.Images.SetKeyName(1, "");
            this.imgToolBar.Images.SetKeyName(2, "");
            this.imgToolBar.Images.SetKeyName(3, "");
            this.imgToolBar.Images.SetKeyName(4, "");
            this.imgToolBar.Images.SetKeyName(5, "");
            this.imgToolBar.Images.SetKeyName(6, "");
            this.imgToolBar.Images.SetKeyName(7, "");
            this.imgToolBar.Images.SetKeyName(8, "");
            this.imgToolBar.Images.SetKeyName(9, "");
            this.imgToolBar.Images.SetKeyName(10, "");
            this.imgToolBar.Images.SetKeyName(11, "");
            this.imgToolBar.Images.SetKeyName(12, "");
            // 
            // gbComments
            // 
            this.gbComments.Controls.Add(this.txtComments);
            this.gbComments.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.gbComments.Location = new System.Drawing.Point(2, 76);
            this.gbComments.Name = "gbComments";
            this.gbComments.Size = new System.Drawing.Size(364, 70);
            this.gbComments.TabIndex = 3;
            this.gbComments.TabStop = false;
            this.gbComments.Text = "         Comments on Assignments and Exams";
            // 
            // txtComments
            // 
            this.txtComments.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtComments.Location = new System.Drawing.Point(4, 14);
            this.txtComments.Multiline = true;
            this.txtComments.Name = "txtComments";
            this.txtComments.Size = new System.Drawing.Size(352, 50);
            this.txtComments.TabIndex = 0;
            // 
            // gbGradingPolicy
            // 
            this.gbGradingPolicy.Controls.Add(this.cmbEditableField);
            this.gbGradingPolicy.Controls.Add(this.lbEditableField);
            this.gbGradingPolicy.Controls.Add(this.txtPCTFinal);
            this.gbGradingPolicy.Controls.Add(this.txtMAXFinal);
            this.gbGradingPolicy.Controls.Add(this.lbPCTFinal);
            this.gbGradingPolicy.Controls.Add(this.lbMaxFinal);
            this.gbGradingPolicy.Controls.Add(this.txtPCTMidterm2);
            this.gbGradingPolicy.Controls.Add(this.txtMAXMidterm2);
            this.gbGradingPolicy.Controls.Add(this.lbPCTMidterm2);
            this.gbGradingPolicy.Controls.Add(this.lbMaxMidterm2);
            this.gbGradingPolicy.Controls.Add(this.txtPCTMidterm1);
            this.gbGradingPolicy.Controls.Add(this.txtMAXMidterm1);
            this.gbGradingPolicy.Controls.Add(this.lbPCTMidterm1);
            this.gbGradingPolicy.Controls.Add(this.lbMaxMidterm1);
            this.gbGradingPolicy.Controls.Add(this.txtHWKDrops);
            this.gbGradingPolicy.Controls.Add(this.txtPCTHWK);
            this.gbGradingPolicy.Controls.Add(this.txtMAXHWK);
            this.gbGradingPolicy.Controls.Add(this.txtNumHWK);
            this.gbGradingPolicy.Controls.Add(this.lbDropsHWK);
            this.gbGradingPolicy.Controls.Add(this.lbPCTHWK);
            this.gbGradingPolicy.Controls.Add(this.lbMaxHWK);
            this.gbGradingPolicy.Controls.Add(this.lbNoHWK);
            this.gbGradingPolicy.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.gbGradingPolicy.Location = new System.Drawing.Point(370, 32);
            this.gbGradingPolicy.Name = "gbGradingPolicy";
            this.gbGradingPolicy.Size = new System.Drawing.Size(354, 116);
            this.gbGradingPolicy.TabIndex = 4;
            this.gbGradingPolicy.TabStop = false;
            this.gbGradingPolicy.Text = "Policy: CSxxx/xxxx/00 (99999) 00 Enrolled";
            this.gbGradingPolicy.Enter += new System.EventHandler(this.gbGradingPolicy_Enter);
            // 
            // cmbEditableField
            // 
            this.cmbEditableField.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmbEditableField.Items.AddRange(new object[] {
            "None"});
            this.cmbEditableField.Location = new System.Drawing.Point(248, 90);
            this.cmbEditableField.Name = "cmbEditableField";
            this.cmbEditableField.Size = new System.Drawing.Size(99, 21);
            this.cmbEditableField.TabIndex = 24;
            this.cmbEditableField.Text = "None";
            this.cmbEditableField.SelectedIndexChanged += new System.EventHandler(this.cmbEditableField_SelectedIndexChanged);
            // 
            // lbEditableField
            // 
            this.lbEditableField.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbEditableField.ForeColor = System.Drawing.SystemColors.ActiveCaption;
            this.lbEditableField.Location = new System.Drawing.Point(245, 69);
            this.lbEditableField.Name = "lbEditableField";
            this.lbEditableField.Size = new System.Drawing.Size(99, 15);
            this.lbEditableField.TabIndex = 23;
            this.lbEditableField.Text = "Editable Field";
            this.lbEditableField.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // txtPCTFinal
            // 
            this.txtPCTFinal.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtPCTFinal.Location = new System.Drawing.Point(321, 45);
            this.txtPCTFinal.Name = "txtPCTFinal";
            this.txtPCTFinal.Size = new System.Drawing.Size(26, 21);
            this.txtPCTFinal.TabIndex = 22;
            // 
            // txtMAXFinal
            // 
            this.txtMAXFinal.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtMAXFinal.Location = new System.Drawing.Point(321, 21);
            this.txtMAXFinal.Name = "txtMAXFinal";
            this.txtMAXFinal.Size = new System.Drawing.Size(26, 21);
            this.txtMAXFinal.TabIndex = 21;
            // 
            // lbPCTFinal
            // 
            this.lbPCTFinal.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbPCTFinal.Location = new System.Drawing.Point(248, 45);
            this.lbPCTFinal.Name = "lbPCTFinal";
            this.lbPCTFinal.Size = new System.Drawing.Size(69, 18);
            this.lbPCTFinal.TabIndex = 20;
            this.lbPCTFinal.Text = "Final %";
            this.lbPCTFinal.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lbMaxFinal
            // 
            this.lbMaxFinal.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbMaxFinal.Location = new System.Drawing.Point(248, 24);
            this.lbMaxFinal.Name = "lbMaxFinal";
            this.lbMaxFinal.Size = new System.Drawing.Size(67, 18);
            this.lbMaxFinal.TabIndex = 19;
            this.lbMaxFinal.Text = "Max. Final";
            this.lbMaxFinal.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtPCTMidterm2
            // 
            this.txtPCTMidterm2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtPCTMidterm2.Location = new System.Drawing.Point(206, 92);
            this.txtPCTMidterm2.Name = "txtPCTMidterm2";
            this.txtPCTMidterm2.Size = new System.Drawing.Size(27, 21);
            this.txtPCTMidterm2.TabIndex = 18;
            // 
            // txtMAXMidterm2
            // 
            this.txtMAXMidterm2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtMAXMidterm2.Location = new System.Drawing.Point(206, 71);
            this.txtMAXMidterm2.Name = "txtMAXMidterm2";
            this.txtMAXMidterm2.Size = new System.Drawing.Size(27, 21);
            this.txtMAXMidterm2.TabIndex = 17;
            // 
            // lbPCTMidterm2
            // 
            this.lbPCTMidterm2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbPCTMidterm2.Location = new System.Drawing.Point(116, 92);
            this.lbPCTMidterm2.Name = "lbPCTMidterm2";
            this.lbPCTMidterm2.Size = new System.Drawing.Size(83, 18);
            this.lbPCTMidterm2.TabIndex = 16;
            this.lbPCTMidterm2.Text = "Midterm 2 %";
            this.lbPCTMidterm2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lbMaxMidterm2
            // 
            this.lbMaxMidterm2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbMaxMidterm2.Location = new System.Drawing.Point(117, 74);
            this.lbMaxMidterm2.Name = "lbMaxMidterm2";
            this.lbMaxMidterm2.Size = new System.Drawing.Size(82, 18);
            this.lbMaxMidterm2.TabIndex = 15;
            this.lbMaxMidterm2.Text = "Max. Mid 2";
            this.lbMaxMidterm2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtPCTMidterm1
            // 
            this.txtPCTMidterm1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtPCTMidterm1.Location = new System.Drawing.Point(206, 42);
            this.txtPCTMidterm1.Name = "txtPCTMidterm1";
            this.txtPCTMidterm1.Size = new System.Drawing.Size(27, 21);
            this.txtPCTMidterm1.TabIndex = 14;
            // 
            // txtMAXMidterm1
            // 
            this.txtMAXMidterm1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtMAXMidterm1.Location = new System.Drawing.Point(206, 23);
            this.txtMAXMidterm1.Name = "txtMAXMidterm1";
            this.txtMAXMidterm1.Size = new System.Drawing.Size(27, 21);
            this.txtMAXMidterm1.TabIndex = 12;
            // 
            // lbPCTMidterm1
            // 
            this.lbPCTMidterm1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbPCTMidterm1.Location = new System.Drawing.Point(117, 42);
            this.lbPCTMidterm1.Name = "lbPCTMidterm1";
            this.lbPCTMidterm1.Size = new System.Drawing.Size(83, 18);
            this.lbPCTMidterm1.TabIndex = 11;
            this.lbPCTMidterm1.Text = "Midterm 1 %";
            this.lbPCTMidterm1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lbMaxMidterm1
            // 
            this.lbMaxMidterm1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbMaxMidterm1.Location = new System.Drawing.Point(116, 26);
            this.lbMaxMidterm1.Name = "lbMaxMidterm1";
            this.lbMaxMidterm1.Size = new System.Drawing.Size(84, 18);
            this.lbMaxMidterm1.TabIndex = 9;
            this.lbMaxMidterm1.Text = "Max. Mid 1";
            this.lbMaxMidterm1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.lbMaxMidterm1.Click += new System.EventHandler(this.lbMaxMidterm1_Click);
            // 
            // txtHWKDrops
            // 
            this.txtHWKDrops.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtHWKDrops.Location = new System.Drawing.Point(84, 90);
            this.txtHWKDrops.Name = "txtHWKDrops";
            this.txtHWKDrops.Size = new System.Drawing.Size(26, 21);
            this.txtHWKDrops.TabIndex = 8;
            // 
            // txtPCTHWK
            // 
            this.txtPCTHWK.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtPCTHWK.Location = new System.Drawing.Point(84, 63);
            this.txtPCTHWK.Name = "txtPCTHWK";
            this.txtPCTHWK.Size = new System.Drawing.Size(26, 21);
            this.txtPCTHWK.TabIndex = 6;
            // 
            // txtMAXHWK
            // 
            this.txtMAXHWK.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtMAXHWK.Location = new System.Drawing.Point(84, 42);
            this.txtMAXHWK.Name = "txtMAXHWK";
            this.txtMAXHWK.Size = new System.Drawing.Size(26, 21);
            this.txtMAXHWK.TabIndex = 5;
            this.txtMAXHWK.TextChanged += new System.EventHandler(this.txtMAXHWK_TextChanged);
            // 
            // txtNumHWK
            // 
            this.txtNumHWK.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtNumHWK.Location = new System.Drawing.Point(84, 21);
            this.txtNumHWK.Name = "txtNumHWK";
            this.txtNumHWK.Size = new System.Drawing.Size(26, 21);
            this.txtNumHWK.TabIndex = 4;
            // 
            // lbDropsHWK
            // 
            this.lbDropsHWK.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbDropsHWK.Location = new System.Drawing.Point(3, 90);
            this.lbDropsHWK.Name = "lbDropsHWK";
            this.lbDropsHWK.Size = new System.Drawing.Size(74, 18);
            this.lbDropsHWK.TabIndex = 3;
            this.lbDropsHWK.Text = "HWK Drops";
            this.lbDropsHWK.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lbPCTHWK
            // 
            this.lbPCTHWK.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbPCTHWK.Location = new System.Drawing.Point(3, 66);
            this.lbPCTHWK.Name = "lbPCTHWK";
            this.lbPCTHWK.Size = new System.Drawing.Size(74, 18);
            this.lbPCTHWK.TabIndex = 2;
            this.lbPCTHWK.Text = "HWK %";
            this.lbPCTHWK.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lbMaxHWK
            // 
            this.lbMaxHWK.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbMaxHWK.Location = new System.Drawing.Point(2, 45);
            this.lbMaxHWK.Name = "lbMaxHWK";
            this.lbMaxHWK.Size = new System.Drawing.Size(74, 18);
            this.lbMaxHWK.TabIndex = 1;
            this.lbMaxHWK.Text = "Max. HWK";
            this.lbMaxHWK.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lbNoHWK
            // 
            this.lbNoHWK.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbNoHWK.Location = new System.Drawing.Point(6, 26);
            this.lbNoHWK.Name = "lbNoHWK";
            this.lbNoHWK.Size = new System.Drawing.Size(74, 18);
            this.lbNoHWK.TabIndex = 0;
            this.lbNoHWK.Text = "No. of HWK";
            this.lbNoHWK.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // gbStudentList
            // 
            this.gbStudentList.Controls.Add(this.cmbMajors);
            this.gbStudentList.Controls.Add(this.lbAddStudentToClass);
            this.gbStudentList.Controls.Add(this.lbChangeStatus);
            this.gbStudentList.Controls.Add(this.txtStudentFilter);
            this.gbStudentList.Controls.Add(this.rdbInactiveStudents);
            this.gbStudentList.Controls.Add(this.rdbActiveStudents);
            this.gbStudentList.Controls.Add(this.dgStudent);
            this.gbStudentList.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.gbStudentList.Location = new System.Drawing.Point(6, 35);
            this.gbStudentList.Name = "gbStudentList";
            this.gbStudentList.Size = new System.Drawing.Size(463, 545);
            this.gbStudentList.TabIndex = 5;
            this.gbStudentList.TabStop = false;
            this.gbStudentList.Text = "Student list :   Filtered  by Status   by Name";
            this.gbStudentList.Visible = false;
            this.gbStudentList.Enter += new System.EventHandler(this.gbStudentList_Enter);
            // 
            // cmbMajors
            // 
            this.cmbMajors.Font = new System.Drawing.Font("Consolas", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cmbMajors.FormattingEnabled = true;
            this.cmbMajors.Location = new System.Drawing.Point(308, 20);
            this.cmbMajors.Name = "cmbMajors";
            this.cmbMajors.Size = new System.Drawing.Size(131, 21);
            this.cmbMajors.TabIndex = 10;
            this.cmbMajors.SelectedIndexChanged += new System.EventHandler(this.cmbMajors_SelectedIndexChanged);
            // 
            // lbAddStudentToClass
            // 
            this.lbAddStudentToClass.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lbAddStudentToClass.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbAddStudentToClass.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.lbAddStudentToClass.ImageIndex = 12;
            this.lbAddStudentToClass.ImageList = this.imgToolBar;
            this.lbAddStudentToClass.Location = new System.Drawing.Point(162, 20);
            this.lbAddStudentToClass.Name = "lbAddStudentToClass";
            this.lbAddStudentToClass.Size = new System.Drawing.Size(76, 22);
            this.lbAddStudentToClass.TabIndex = 9;
            this.lbAddStudentToClass.Text = "MATH220";
            this.lbAddStudentToClass.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.lbAddStudentToClass.Click += new System.EventHandler(this.lbAddStudentToClass_Click);
            // 
            // lbChangeStatus
            // 
            this.lbChangeStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.lbChangeStatus.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbChangeStatus.ImageIndex = 10;
            this.lbChangeStatus.ImageList = this.imgToolBar;
            this.lbChangeStatus.Location = new System.Drawing.Point(72, 22);
            this.lbChangeStatus.Name = "lbChangeStatus";
            this.lbChangeStatus.Size = new System.Drawing.Size(26, 18);
            this.lbChangeStatus.TabIndex = 8;
            this.lbChangeStatus.Click += new System.EventHandler(this.lbChangeStatus_Click);
            // 
            // txtStudentFilter
            // 
            this.txtStudentFilter.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtStudentFilter.Location = new System.Drawing.Point(244, 21);
            this.txtStudentFilter.Name = "txtStudentFilter";
            this.txtStudentFilter.Size = new System.Drawing.Size(52, 21);
            this.txtStudentFilter.TabIndex = 3;
            this.txtStudentFilter.TextChanged += new System.EventHandler(this.txtStudentFilter_TextChanged);
            // 
            // rdbInactiveStudents
            // 
            this.rdbInactiveStudents.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.rdbInactiveStudents.Location = new System.Drawing.Point(8, 21);
            this.rdbInactiveStudents.Name = "rdbInactiveStudents";
            this.rdbInactiveStudents.Size = new System.Drawing.Size(62, 20);
            this.rdbInactiveStudents.TabIndex = 2;
            this.rdbInactiveStudents.Text = "Inactive";
            this.rdbInactiveStudents.CheckedChanged += new System.EventHandler(this.rdbInactiveStudents_CheckedChanged);
            // 
            // rdbActiveStudents
            // 
            this.rdbActiveStudents.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.rdbActiveStudents.Checked = true;
            this.rdbActiveStudents.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.rdbActiveStudents.Location = new System.Drawing.Point(106, 21);
            this.rdbActiveStudents.Name = "rdbActiveStudents";
            this.rdbActiveStudents.Size = new System.Drawing.Size(54, 20);
            this.rdbActiveStudents.TabIndex = 1;
            this.rdbActiveStudents.TabStop = true;
            this.rdbActiveStudents.Text = "Active";
            this.rdbActiveStudents.CheckedChanged += new System.EventHandler(this.rdbActiveStudents_CheckedChanged);
            // 
            // dgStudent
            // 
            this.dgStudent.CaptionText = "Active Students";
            this.dgStudent.DataMember = "";
            this.dgStudent.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.dgStudent.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dgStudent.Location = new System.Drawing.Point(10, 48);
            this.dgStudent.Name = "dgStudent";
            this.dgStudent.Size = new System.Drawing.Size(434, 480);
            this.dgStudent.TabIndex = 5;
            this.dgStudent.Navigate += new System.Windows.Forms.NavigateEventHandler(this.dgStudent_Navigate);
            // 
            // FrmClassGrades
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.AutoScroll = true;
            this.ClientSize = new System.Drawing.Size(734, 651);
            this.Controls.Add(this.gbGradingPolicy);
            this.Controls.Add(this.toolbarTGradebook);
            this.Controls.Add(this.dgGrade);
            this.Controls.Add(this.gbComments);
            this.Controls.Add(this.gbCourseOffering);
            this.Controls.Add(this.gbStudentList);
            this.ImeMode = System.Windows.Forms.ImeMode.Alpha;
            this.Menu = this.mnTGradebook;
            this.Name = "FrmClassGrades";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Grade Book - Built on Visual Studio 2010 & Oracle 10g Running on Delphi with Clie" +
                "nt 11g";
            this.Load += new System.EventHandler(this.FrmClassGrades_Load);
            ((System.ComponentModel.ISupportInitialize)(this.dgGrade)).EndInit();
            this.gbCourseOffering.ResumeLayout(false);
            this.gbCourseOffering.PerformLayout();
            this.gbComments.ResumeLayout(false);
            this.gbComments.PerformLayout();
            this.gbGradingPolicy.ResumeLayout(false);
            this.gbGradingPolicy.PerformLayout();
            this.gbStudentList.ResumeLayout(false);
            this.gbStudentList.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.dgStudent)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}

		#endregion

		#region Get and Save Changes

		private void checkForExit()
		{
			int k1 = getGradeChanges(),
				k3 = getStudentChanges(),
				k2 = getPolicyChanges(),
				k = k1 + k2 + k3;

			if ( k > 0 ) 
			{
                /*
				DialogResult ans = MessageBox.Show(this, k + " record" +
					(k==1? " has" : "s have" ) +
					" been Changed in Grade, Policy and/or Student table." +
					"\nDo you want to save the changes to the database?",
					"Confirmation of Saving Changes", MessageBoxButtons.YesNo);
                 * */
				if (  true ) //ans == DialogResult.Yes ) 
				{
					if ( k1 > 0 ) TGradebookDB.saveGrade( ds );
					if ( k2 > 0 ) TGradebookDB.savePolicy( ds );
					if ( k3 > 0 ) TGradebookDB.saveStudent(dtStudent );
				}
			}
			TGradebookDB.saveGrade( ds );
			TGradebookDB.saveStudent(dtStudent );
			TGradebookDB.savePolicy( ds );
			Application.Exit();
		}

		public void saveAllChanges()
		{
			// The editing action will not end if you don't move to the next
			// row. The following two statements will close the editing when
			// out moving to the next row.
			if ( getPolicyChanges() > 0 ) TGradebookDB.savePolicy ( ds );
			if ( getStudentChanges()> 0 ) TGradebookDB.saveStudent( dtStudent );
			if ( getGradeChanges() > 0 ) TGradebookDB.saveGrade( ds );
		}

		private int getDataTableChanges( DataTable pDT) 
		{
			if ( pDT == null || pDT.Rows == null ) return 0;
			DataTable tDT = pDT.GetChanges();
			return tDT == null ? 0 : tDT.Rows.Count ;
		}
		
		private int getStudentChanges() 
		{
			try 
			{
				if ( dtStudent.Rows.Count > 0 )
					dtStudent.Rows.Find( dgStudent[dgStudent.CurrentRowIndex, 0] ).EndEdit();

				return getDataTableChanges(dtStudent);
			} 
			catch (Exception ex ) { Console.WriteLine(ex.StackTrace); return 0; }
		}

		private int getGradeChanges() 
		{
			try 
			{
				if ( dtGrade.Rows.Count > 0 ) 
						dtGrade.Rows.Find(dgGrade[dgGrade.CurrentRowIndex, 0]).EndEdit();
				return getDataTableChanges(dtGrade);
			}
            catch (Exception ex) { Console.WriteLine(ex.StackTrace); return 0; }
		}

		private int getPolicyChanges()
		{
			try 
			{
				dtPolicy.Rows[0].EndEdit();
				return getDataTableChanges( dtPolicy );
            }
            catch (Exception ex) { Console.WriteLine(ex.StackTrace); return 0; }
		}
		#endregion All Objects

		#region H. Wang -- STUDENT-related function members


		private void changStudentID() 
		{
			new FrmChangID( dgStudent[dgStudent.CurrentRowIndex,0].ToString() ).ShowDialog ();
			if ( GlobalConstsVars.studentIDChanged )
			{
				loadStudents( this.strActiveOrInactive );
				// this.displayGradesInGrid();
			}
		}

		public void removeStudentFromClass()
		{ 
			DataRow row = dtGrade.Rows.Find(dgGrade[dgGrade.CurrentRowIndex, 0]);
			System.Windows.Forms.DialogResult  ans = MessageBox.Show(this, 
				"Remove [" + row[3] + " " + row[2] +
				"]\nfrom " + strCurrentClass + " ?", "Deletion Confirmation", MessageBoxButtons.YesNo );
			if ( ans != DialogResult.Yes ) return;
			row.Delete();
		}

		public void removeStudentAndAllClasses() 
		{
			string msg = "Remove " + dgStudent[dgStudent.CurrentRowIndex, 2] + " " +
						dgStudent[dgStudent.CurrentRowIndex, 1] +
						" [" + dgStudent[dgStudent.CurrentRowIndex, 0] +
						"] from database and\nalong with all classes taken from " + GlobalConstsVars.IName + " ?";
			System.Windows.Forms.DialogResult ans = MessageBox.Show(this, msg,
								"Deletion Confirmation", MessageBoxButtons.YesNo);
			if ( ans == DialogResult.Yes ) 
			{
				int k = TGradebookDB.removeStudentAndAllClasses(
					int.Parse(dgStudent[dgStudent.CurrentRowIndex, 0].ToString()), GlobalConstsVars.IID );
                this.loadStudents(this.strActiveOrInactive);
                
                /*
                 * if ( k < 1 ) msg = "The courses taked from this instructor by the sturdents\n" +
                                   "are removed. However, the student is not removed, since\n" +
                                   "the student has taken course(s) from other intructor(s).";
                   else msg = k + " records  deleted!";
                 * MessageBox.Show(this, msg, "Information" );
                 * */
			}

		}
		public void changeStudentStatus() 
		{

			string	tmpStatus = null,
				msg = "Change the status of " + dgStudent[dgStudent.CurrentRowIndex, 2] + " "
				+ dgStudent[dgStudent.CurrentRowIndex, 1]+ "\n to ";
			if ( strActiveOrInactive.Equals("Active") ) 
			{
				msg += "'Inactive' ?";
				tmpStatus = "N";
			} 
			else 
			{
				msg += "'Active' ?";
				tmpStatus = "Y";
			}
			System.Windows.Forms.DialogResult ans = MessageBox.Show (
				msg, "Status Change Confirmation", System.Windows.Forms.MessageBoxButtons.YesNo );
			if (ans == DialogResult.No ) return ;
			DataRow row = dtStudent.Rows.Find( dgStudent[dgStudent.CurrentRowIndex,0] );
			row.BeginEdit();
			row[3] = tmpStatus;
			row.EndEdit();
			this.dgStudent.CaptionText = strActiveOrInactive + " : " + dtStudent.DefaultView.Count;
		}

		public void addStudentToCurrentClass()
		{
			if ( strCurrentClass != null ) {
				int row = dgStudent.CurrentRowIndex; 
				string strMsg = "Add " + dgStudent[row, 2] + " " + dgStudent[row, 1] +
								" to " + strCurrentClass + "?";
				System.Windows.Forms.DialogResult ans = System.Windows.Forms.MessageBox.Show(
							this, strMsg, "Add a Student to class", MessageBoxButtons.YesNo);
				if ( ans == DialogResult.Yes ) 
				{
						DataRow dRow = dtGrade.NewRow();
						dRow["CID"] = GlobalConstsVars.CID;
						dRow["SID"] = dgStudent[row, 0];
						dRow["FirstName"] = dgStudent[row, 2];
						dRow["LastName"] = dgStudent[row, 1];
						dRow["grade"] = "-"; dRow["Comments"]= "";
						dRow["total"] = 0.0;
						dRow["Ranking"] = 0.0;
						for ( int i = 1; i < 5 + GlobalConstsVars.hwkCnt - 1; i ++ ) 
							dRow[i+6] = 0;
						dtGrade.Rows.Add(dRow);
				}
			}
		}
		public void loadStudents( string activeOrInactive ) 
		{
			int k = getStudentChanges();
            if (k > 0) TGradebookDB.saveStudent(dtStudent);
            /*
			if ( k > 0 ) 
			{
				DialogResult ans = MessageBox.Show(this, k + " record" +
					(k==1? " has" : "s have" ) +
					" been Changed." +
					"\nDo you want to save the changes to the database?",
					"Confirmation of Saving Changes", MessageBoxButtons.YesNo);
				if (ans == DialogResult.Yes ) TGradebookDB.saveStudent(dtStudent);
			}
            */
			strActiveOrInactive = activeOrInactive;

			if (strActiveOrInactive.Equals("Active"))
				this.lbChangeStatus.ImageIndex = 10;
			else this.lbChangeStatus.ImageIndex = 9 ;

			dtStudent = TGradebookDB.getStudents("V" + strActiveOrInactive + "Students" );
			dtStudent.PrimaryKey = new DataColumn [] {dtStudent.Columns["SID"]} ;
			dtStudent.Columns["Active"].ColumnMapping = MappingType.Hidden;
			dtStudent.DefaultView.RowFilter = "Active = '" + (strActiveOrInactive.Equals("Active")? "Y": "N") + "'";
			this.dgStudent.DataSource = dtStudent;
			this.dgStudent.CaptionText = strActiveOrInactive + " : " + dtStudent.DefaultView.Count;
			dtStudent.DefaultView.AllowNew = false;
		}

		private void reverseVisibility(string tag, string tip ) 
		{
			this.Size = this.windowSize[tbbStudentsOrGrade.Pushed ? 1 : 0];
			this.mitStudent.Enabled = ! this.mitStudent.Enabled ;
			this.mitClass.Enabled = ! this.mitClass.Enabled ;
			this.mitReport.Enabled = ! this.mitReport.Enabled ;
			this.gbGradingPolicy.Visible = ! gbGradingPolicy.Visible;
			this.gbCourseOffering.Visible = ! gbCourseOffering.Visible;
			this.gbComments.Visible = ! gbComments.Visible;
			this.dgGrade.Visible = !dgGrade.Visible;
			this.gbStudentList.Visible = !gbStudentList.Visible;
			this.tbbStudentsOrGrade.ToolTipText = gbStudentList.Visible ?
						"Display a class grade page" : "Display student list page";
			for ( int  i = 0; i < this.toolbarTGradebook.Buttons.Count - 2; i ++)
					toolbarTGradebook.Buttons[i].Enabled = !toolbarTGradebook.Buttons[i].Enabled ;
		}

		#endregion

		#region H. Wang - CLASS/Grades/POLICY related function members.

		private void setNewClassVisibility(bool vis ) 
		{
			this.gbGradingPolicy.Visible = !vis;
			this.gbComments.Visible = !vis;
			this.dgGrade.Visible = !vis;
			this.toolbarTGradebook.Visible = !vis;
			this.txtClassFilter.Visible = !vis;
			this.btnAddNewCourse.Visible = vis;
			this.btnCancellNewCourse.Visible = vis;
		}
		private void setUpForNewClass(bool upOrDown) 
		{
			setNewClassVisibility ( upOrDown );
			this.Size = this.windowSize[upOrDown? 2: this.tbbStudentsOrGrade.Pushed? 1: 0];
		}
		public string getFileName( string dialogType ) 
		{
			FileDialog fDialog ;
			if ( dialogType.Equals("open") ) 
					fDialog = new OpenFileDialog();
			else	fDialog = new SaveFileDialog() ;
 
			fDialog.InitialDirectory = typeof(FrmClassGrades).Assembly.Location;
			fDialog.Filter = "Data Files (*.dat)|*.dat|Text Files (*.txt)|*.txt |All Files (*.*)|*.*";
			fDialog.FileName ="Class" + cmbCourseName.Text.Trim() + cmbSection.Text.Trim() + "sco.dat";

			DialogResult ans = fDialog.ShowDialog();
			if ( ans == DialogResult.Cancel ) return "";
			return fDialog.FileName;
			
		}
		public void displayFileContents()
		{
			string fileName = getFileName("open");
			if ( fileName.Equals("") ) return ;
			System.Diagnostics.Process.Start("Notepad", fileName ); 
		}
		private string makeTitleLines( ) 
		{
			string title = "Grade Report for " + cmbCourseName.Text + '-' + 
					cmbSection.Text + ' ' + cmbQuarter.Text + ", " + cmbYear.Text + "\r\n";
			title += "Enrollment: " + dtGrade.Rows.Count + "\r\n";
			title += "Last Updated: " + string.Format("{0:F}", System.DateTime.Now) + "\r\n";
			title += "Application: " + "TGradebook system (CGI in C++, Oracle Databse, Visual Studio.NET/C#)" + "\r\n";
			title += "Author: H. Wang, Dec. 1996, Updated 2004 (661-664-2357)" + "\r\n";
			title += "\r\n";
			return title;
		}

		private string makeMaxMinLines( int[] maxs, int[] mins ) 
		{
			string maxMinLines = "Assignment/Exams: ";
			for ( int i = 1; i <= GlobalConstsVars.hwkCnt; i ++ ) maxMinLines += string.Format("{0:0.}", i).PadRight(7);
			maxMinLines += "Mid1   Mid2   Final  UTD%   Rank   Grade" + "\r\n";
			maxMinLines += "Max:Min".PadRight(18);
			for ( int i = 0; i < maxs.Length; i ++ ) 
				maxMinLines += (maxs[i] + ":" + mins[i]).PadRight(7);
			maxMinLines += "A:F" + "\r\n";
			return maxMinLines;
		}
		private void setMaxMin( int[] maxs, int[] mins, int idx, int v ) 
		{
			maxs[idx] = maxs[idx] < v ? v : maxs[idx];
			mins[idx] = mins[idx] > v ? v : mins[idx];
		}
		public void saveClassGradeToFile() 
		{
			saveAllChanges();
			int[] maxs = new int[GlobalConstsVars.hwkCnt + 5];
			int[] mins = new int[GlobalConstsVars.hwkCnt + 5];
			float totalMid = 0, totalMid2 = 0, totalFinal = 0;

			dtGrade.DefaultView.RowFilter = this.txtClassFilter.Text = "";

			for ( int i = 0; i < mins.Length ; i ++ ) mins[i] = 100;

			try 
			{
				string line = "";
				float v;
				for ( int i = 0; i < dtGrade.Rows.Count; i++ ) 
				{
					line += "\r\n";
                    // Get student ID
				    line += string.Format( "{0:0###.}", Int64.Parse(dgGrade[i, 0].ToString()) % 10000 ).PadRight(18);
					for ( int j = 1; j <= GlobalConstsVars.hwkCnt +  3; j ++ ) 
					{
						v = float.Parse( dgGrade[i, j + 5].ToString () );
						setMaxMin(maxs, mins, j - 1, (int) v);
						line += String.Format("{0:0.0}", v).PadRight(7);

					}
					line += string.Format("{0:0.0}", float.Parse (dgGrade[i, 4].ToString())).PadRight(7) +		// Ranking-3, Total-4, Grade=5, HW1-6, ... HWK-5+hwkCnt, Mid1-5+hwkCnt, ...
						  string.Format("{0:0.}", int.Parse(dgGrade[i, 3].ToString ())).PadRight(7) +
										(dgGrade[i, 5]).ToString() + "\r\n";
					line += "Comments: " + dgGrade[i, 5 + GlobalConstsVars.hwkCnt + 4] + "\r\n";
					v = float.Parse( dgGrade[i, 4].ToString() );
					setMaxMin(maxs, mins, GlobalConstsVars.hwkCnt +  3, (int) v);
					v = float.Parse ( dgGrade[i, 3].ToString ());
					setMaxMin(maxs, mins, GlobalConstsVars.hwkCnt +  4, (int) v);
					totalMid += float.Parse  ( dgGrade[i, GlobalConstsVars.hwkCnt + 6].ToString ());
					totalMid2 += float.Parse (dgGrade[i, GlobalConstsVars.hwkCnt + 7].ToString ());
					totalFinal += float.Parse (dgGrade[i, GlobalConstsVars.hwkCnt + 8].ToString());
				}
				string examString = "Midterm 1 (Hi, Low, Average: " + maxs[GlobalConstsVars.hwkCnt] + ", " +
									mins[GlobalConstsVars.hwkCnt] + ", " + string.Format("{0:0.0}", totalMid / dtGrade.Rows.Count ) + "); ";

				examString += "Midterm 2 (Hi, Low, Average: "+ maxs[GlobalConstsVars.hwkCnt + 1] + ", " +
							mins[GlobalConstsVars.hwkCnt + 1] + ", " + string.Format("{0:0.0}", totalMid2 / dtGrade.Rows.Count) + "); ";

				examString += "Final (Hi, Low, Average: " + maxs[GlobalConstsVars.hwkCnt+2] + ", " +
							mins[GlobalConstsVars.hwkCnt+2] + ", " + string.Format("{0:0.0}", totalFinal / dtGrade.Rows.Count) + ")\r\n\r\n";

				string fileName = getFileName("save");
				if ( fileName.Equals("")) return ;
				StreamWriter file = new StreamWriter(fileName) ;
				file.Write( makeTitleLines() + examString + makeMaxMinLines(maxs, mins) + line );
				file.Close();
			} 
			catch (System.Exception e ) { Console.WriteLine(e.StackTrace ); }
		}
		private void setGlobalCIDbyYQNSitableFieldNames() 
		{
			cmbEditableField.Items.Clear();
			cmbEditableField.Items.Add("None");
			cmbEditableField.Text = "None";
			for ( int i = 6; i < dtGrade.Columns.Count - 1; i ++ ) 
				cmbEditableField.Items.Add(dtGrade.Columns[i].ColumnName);
		}
		private void setGridColumnWidth()
		{
			try 
			{
				dgGrade.TableStyles.Add(new DataGridTableStyle());
				dgGrade.TableStyles[0].MappingName = "VGrades";

				dgGrade.TableStyles[0].GridColumnStyles[0].Width  = 0;  // SID
				dgGrade.TableStyles[0].GridColumnStyles[1].Width  = 60;  // last Name
				dgGrade.TableStyles[0].GridColumnStyles[2].Width  = 60; // First name
				dgGrade.TableStyles[0].GridColumnStyles[3].Width  = 40;  // Rank
				dgGrade.TableStyles[0].GridColumnStyles[4].Width  = 40;  // UTD %
				dgGrade.TableStyles[0].GridColumnStyles[5].Width  = 25;  // Gr
				for ( int i = 0; i < GlobalConstsVars.hwkCnt; i ++ ) 
					dgGrade.TableStyles[0].GridColumnStyles[i+6].Width  = 40;

				dgGrade.TableStyles[0].GridColumnStyles[GlobalConstsVars.hwkCnt + 6].Width  = 45;
				dgGrade.TableStyles[0].GridColumnStyles[GlobalConstsVars.hwkCnt + 7].Width  = 45;
				dgGrade.TableStyles[0].GridColumnStyles[GlobalConstsVars.hwkCnt + 8].Width  = 45;
				dgGrade.TableStyles[0].GridColumnStyles[GlobalConstsVars.hwkCnt + 9].Width  = 0;
			} 
			catch ( System.Exception e ) { Console.WriteLine(e.StackTrace); }   
			finally { }
		}

		private void rebindGradeGridWithTable() 
		{

			// Make First and last names, Ranking, UPT PCT, Letter grade,
			// HW1, .... HWk, midterm1, midterm 2 and final not editable.
			for ( int k = 0; k < ds.Tables["VGrades"].Columns.Count - 1; k ++ )
				if ( k != curEditableCol ) dtGrade.Columns[k].ReadOnly = true; 
				else dtGrade.Columns[k].ReadOnly = false;

			// dtGrade.Columns["Comments"].ColumnMapping = MappingType.Hidden;
			dtGrade.Columns["CID"].ColumnMapping = MappingType.Hidden;
			// dtGrade.Columns["SID"].ColumnMapping = MappingType.Hidden;
			dgGrade.DataSource = null;
			dgGrade.TableStyles.Clear();
			dgGrade.DataSource = dtGrade;
			setGridColumnWidth();
		}

		private void displayGradesInGrid( ) 
		{
		
			int k = getGradeChanges() + getPolicyChanges();
			if ( k > 0 ) 
			{
				DialogResult ans = MessageBox.Show(this, k + " record" +
					(k==1? " has" : "s have" ) +
					" been Changed in Grade and/or Policy table." +
					"\nDo you want to save the changes to the database?",
					"Confirmation of Saving Changes", MessageBoxButtons.YesNo);
				if (ans == DialogResult.Yes ) 
				{
					TGradebookDB.saveGrade( ds );
					TGradebookDB.savePolicy( ds );
				}
			}

            // Set the required course info into glable variables
            GlobalConstsVars.cYear    = System.Int32.Parse( this.cmbYear.Text );
            GlobalConstsVars.cQuarter = this.cmbQuarter.Text;
            GlobalConstsVars.cName = this.cmbCourseName.Text;
            GlobalConstsVars.cSection = System.Int16.Parse(this.cmbSection.Text);
			TGradebookDB.setGlobleCIDbyYQNS( );

			if ( GlobalConstsVars.CID <= 0 ) 
			{
				strCurrentClass = null;
				Console.WriteLine("Course ID is negative.");
			}
			else
			{
				this.lbAddStudentToClass.Text = cmbCourseName.Text;
				strCurrentClass = cmbCourseName.Text + "-" + cmbSection.Text + "/" + cmbQuarter.Text
					+ "/" + cmbYear.Text;
				try 
				{
					if ( ds != null ) ds.Dispose();
					ds = TGradebookDB.getGradesAndPolicy();
					dtGrade = ds.Tables["VGrades"]; //.DefaultView;
					dtPolicy = ds.Tables["Policy"];
					dtGrade.PrimaryKey = new DataColumn [] { dtGrade.Columns["SID"] }; //dtGrade.Columns["LastName"], dtGrade.Columns["FirstName"]} ;
					dtGrade.DefaultView.AllowNew = false;
					setGlobalCIDbyYQNSitableFieldNames();
					rebindGradeGridWithTable();

					// if ( cm != null && cm.Count > 0 ) cm.RemoveAt (0);
					cm = (CurrencyManager) this.BindingContext[dgGrade.DataSource, dgGrade.DataMember];
					if (txtComments.DataBindings.Count > 0) txtComments.DataBindings.Clear();
					txtComments.DataBindings.Add("Text", dgGrade.DataSource, "Comments");
					dgGrade.CaptionText = "Click right mouse button on row header to remove a student from the class.";
					bindPolicy();
				} 
				catch (System.Exception e1) { Console.WriteLine (e1.StackTrace );  }	 
			}  
		} 
		private void bindPolicy () 
		{
			if (txtNumHWK.DataBindings.Count > 0) txtNumHWK.DataBindings.Clear();
			txtNumHWK.DataBindings.Add("Text", ds, "Policy.NumHWK");
			if (txtPCTHWK.DataBindings.Count > 0) txtPCTHWK.DataBindings.Clear();
			txtPCTHWK.DataBindings.Add("Text", ds, "Policy.PCTHWK");
			if (txtHWKDrops.DataBindings.Count > 0) txtHWKDrops.DataBindings.Clear();
			txtHWKDrops.DataBindings.Add("Text", ds, "Policy.HWKDrops");
			if (txtMAXHWK.DataBindings.Count > 0) txtMAXHWK.DataBindings.Clear();
			txtMAXHWK.DataBindings.Add("Text", ds, "Policy.MAXHWK");
			if (txtMAXMidterm1.DataBindings.Count > 0) txtMAXMidterm1.DataBindings.Clear();
			txtMAXMidterm1.DataBindings.Add("Text", ds, "Policy.MAXMidterm1");
			if (txtPCTMidterm1.DataBindings.Count > 0) txtPCTMidterm1.DataBindings.Clear();
			txtPCTMidterm1.DataBindings.Add("Text", ds, "Policy.PCTMidterm1");
			if (txtMAXMidterm2.DataBindings.Count > 0) txtMAXMidterm2.DataBindings.Clear();
			txtMAXMidterm2.DataBindings.Add("Text", ds, "Policy.MAXMidterm2");
			if (txtPCTMidterm2.DataBindings.Count > 0) txtPCTMidterm2.DataBindings.Clear();
			txtPCTMidterm2.DataBindings.Add("Text", ds, "Policy.PCTMidterm2");
			if (txtMAXFinal.DataBindings.Count > 0) txtMAXFinal.DataBindings.Clear();
			txtMAXFinal.DataBindings.Add("Text", ds, "Policy.MAXFinal");
			if (txtPCTFinal.DataBindings.Count > 0) txtPCTFinal.DataBindings.Clear();
			txtPCTFinal.DataBindings.Add("Text", ds, "Policy.PCTFinal");
            this.gbGradingPolicy.Text = "Policy: " + cmbCourseName.Text + "-" + 
                cmbSection.Text + "/" + cmbQuarter.Text + "/" + cmbYear.Text + 
                ", (" + GlobalConstsVars.CID + ") " + dtGrade.Rows.Count + " Enrolled";
            ((CurrencyManager) this.BindingContext[ds,"Policy"]).ResumeBinding();

		}
		#endregion

		#region H. Wang -- Event Handlers

		private void FrmClassGrades_Load(object sender, System.EventArgs e)
		{
			this.Text = this.Text + " - " + GlobalConstsVars.IName;
			dgGrade.CurrentCellChanged += new EventHandler(dgGrade_CurrentCellChanged);
			formOrigWidth = this.Width;
			formOrigHeight = this.Height;
			Console.WriteLine ("Form width-Height: " + formOrigWidth + "-" + formOrigHeight);
			this.Resize += new EventHandler(FrmClassGrades_Resize);
			this.cmbCourseName.SelectedIndexChanged +=new EventHandler(cmbCourseName_SelectedIndexChanged);
			this.cmbYear.SelectedIndexChanged +=new EventHandler(cmbYear_SelectedIndexChanged);
			this.cmbQuarter.SelectedIndexChanged += new EventHandler(cmbQuarter_SelectedIndexChanged);
			this.cmbSection.SelectedIndexChanged += new EventHandler(cmbSection_SelectedIndexChanged);
			this.dgGrade.MouseUp +=new MouseEventHandler(dgGrade_MouseUp);
			// new FrmChangID ( dgStudent[dgStudent.CurrentRowIndex, 0].ToString() ).ShowDialog();
			this.txtStudentFilter.KeyUp +=new KeyEventHandler(txtStudentFilter_KeyUp);
			dgStudent.MouseUp += new MouseEventHandler(dgStudent_MouseUp);
			this.Closing += new CancelEventHandler(FrmClassGrades_Closing);

			TGradebookDB.fillYears( cmbYear );
            if (cmbYear.Items.Count > 0) { cmbYear.SelectedIndex = 0; cmbYear.Text = cmbYear.Items[0].ToString(); }
			loadStudents( strActiveOrInactive );
            TGradebookDB.fillMajors(cmbMajors);

		}

		public void cmbYear_SelectedIndexChanged( object sender, EventArgs e ) 
		{
			if ( cmbQuarter.Text.Equals ("") ) return ;
			DateTime dt = DateTime.Now;
			int mth = dt.Month, day = dt.Day;
			switch ( mth ) 
			{
				case 1: case 2: case 12: 
                    this.cmbQuarter.SelectedIndex = 1; break;
				case 3: if (day <= 25) this.cmbQuarter.SelectedIndex = 1;
						else this.cmbQuarter.SelectedIndex = 2;
					break;
				case 4: case 5: case 6:
					this.cmbQuarter.SelectedIndex = 2; break;
				case 9: case 10: case 11:
					this.cmbQuarter.SelectedIndex = 0; break;
			}
            cmbCourseName.Items.Clear ();
			TGradebookDB.fillCourseNamesByYearQuarter( cmbYear.Text, cmbQuarter.Text, this.cmbCourseName);
			if (cmbCourseName.Items.Count > 0) cmbCourseName.SelectedIndex = 0;
		}
		public void cmbQuarter_SelectedIndexChanged( object sender, EventArgs e ) 
		{
			if ( cmbYear.Text.Equals("") ) return;
			TGradebookDB.fillCourseNamesByYearQuarter( cmbYear.Text, cmbQuarter.Text, this.cmbCourseName);
			if (cmbCourseName.Items.Count > 0) cmbCourseName.SelectedIndex = 0;
		}

		public void cmbCourseName_SelectedIndexChanged( object sender, EventArgs e ) 
		{
			if ( cmbYear.Text.Equals("") || cmbQuarter.Text.Equals("") ) return;
			if ( this.cmbSection.SelectedIndex != 0 ) this.cmbSection.SelectedIndex = 0;
			else displayGradesInGrid();
			
		}

		public void cmbSection_SelectedIndexChanged( object sender, EventArgs e ) 
		{
			if ( cmbCourseName.Text.Equals("") ) return;
			displayGradesInGrid();
		}

		private void FrmClassGrades_Resize(object sender, EventArgs e) 
		{
			Form c = (Form) sender;
			if ( this.Width > (this.gbGradingPolicy.Left + gbGradingPolicy.Width + 20 ) ) 
				dgGrade.Width  = this.Width - dgGrade.Left - 30;
			else dgGrade.Width = this.gbGradingPolicy.Left + gbGradingPolicy.Width;
			if ( this.Height > dgGrade.Top + 100) 
				dgGrade.Height  = this.Height - dgGrade.Top - 80;
			if ( this.toolbarTGradebook.Visible == false ) windowSize[2] = this.Size;
			else if ( this.tbbStudentsOrGrade.Pushed ) windowSize[1] = this.Size;
				 else  windowSize[0] = this.Size;
		}

		private void dgGrade_CurrentCellChanged( object sender,  EventArgs  e) 
		{
			DataRow row = dtGrade.Rows.Find(dgGrade[dgGrade.CurrentRowIndex, 0]);
			// Console.WriteLine ("CurrencyManager Position: " + cm.Position);
			dgGrade.CaptionText = dgGrade[cm.Position, 1] + ", " + dgGrade[cm.Position, 2] + "---" +
				row[2] + ", " + row[3];
		}

		private void toolbar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if ( e.Button.Tag.Equals("addNewStudent") ) {
				int recCnt = dtStudent.Rows.Count ;
				new FrmNewStudent(dtStudent, cmbMajors ).ShowDialog();
				if ( recCnt != dtStudent.Rows.Count  )
					dgStudent.CaptionText = strActiveOrInactive + " : " + dtStudent.Rows.Count ;
				return ;
			}

			/* Save Grading policy and class grades */
			if ( e.Button.Tag.Equals("removeStudentFromList")) {
				removeStudentAndAllClasses();
				return ;
			}
			if ( e.Button.Tag.Equals("addNewClass")) {
				setUpForNewClass( true );
				return ; 
			}
			if ( e.Button.Tag.Equals("printReport")) {
				saveAllChanges();
				//new FrmReport( new DataSet1()).Show();
				return ;
			}
			if ( e.Button.Tag.Equals("showStudents")) {
				e.Button.Tag = "showGrades";
				reverseVisibility("showGrades", "Show class grade list");
				return ;
			} 
			
			if ( e.Button.Tag.Equals("showGrades")) 
			{
				e.Button.Tag = "showStudents";
				reverseVisibility("showStudents", "Show student list");
				return ;
			} 

			if ( e.Button.Tag.Equals("saveAll") ) 
			{
				try 
				{
					saveAllChanges();
					displayGradesInGrid();
					if (this.tbbStudentsOrGrade.Pushed ) dgGrade.Visible = false;
					this.loadStudents( this.strActiveOrInactive );
					return;
				} 
				catch (System.ArgumentOutOfRangeException ex ) { Console.WriteLine (ex.StackTrace );}
			}
			/* Calculate the uptodate total points and rankings of a class */
			if ( e.Button.Tag.Equals("calcTotal") ) 
			{
				saveAllChanges();
				TGradebookDB.culateTotal();
				this.displayGradesInGrid();
			}
		}

		private void cmbEditableField_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			preEditableCol = curEditableCol ;
			curEditableCol = cmbEditableField.SelectedIndex <= 0 ? - 1: cmbEditableField.SelectedIndex + 5;
			rebindGradeGridWithTable();
			return ;
		}

		private void mitFile_Click(object sender, System.EventArgs e)
		{
		
		}
		private void txtStudentFilter_KeyUp(object sender, KeyEventArgs e)
		{
			try 
			{
				// A BUG? If the filter expresion result DataTable.DefaultView.Count < 1
				// for the first time, the system will hung up for seconds. After the
				// first-time hang-up, it will be fine.
				if ( e.KeyCode != System.Windows.Forms.Keys.Enter ) return;
				dtStudent.DefaultView.RowFilter = "Active like '" + (strActiveOrInactive.Equals("Active") ? "Y" : "N") + 
					"' AND (firstName like '" + txtStudentFilter.Text +
					"*' OR lastName like '" + txtStudentFilter.Text + "*')";
				if (dtStudent.DefaultView.Count < 1) 
				{
					txtStudentFilter.SelectAll();
					return; 
				}
			}
			catch (System.Exception ex) { Console.WriteLine( ex.StackTrace ); }
		}

		private void txtClassFilter_TextChanged(object sender, System.EventArgs e)
		{
			dtGrade.DefaultView.RowFilter = " firstName like '" + txtClassFilter.Text +
											"*' OR lastName like '" + txtClassFilter.Text + "*'";
		}

		private void rdbInactiveStudents_CheckedChanged(object sender, System.EventArgs e)
		{
			if (rdbInactiveStudents.Checked) loadStudents( rdbInactiveStudents.Text );
		}

		private void rdbActiveStudents_CheckedChanged(object sender, System.EventArgs e)
		{
			if (rdbActiveStudents.Checked) loadStudents( rdbActiveStudents.Text );
		}

		private void lbAddStudentToClass_Click(object sender, System.EventArgs e)
		{
			addStudentToCurrentClass();
			return ;
		}
		private void dgGrade_MouseUp(object sender, MouseEventArgs e)
		{
			if ( e.Button == System.Windows.Forms.MouseButtons.Right ) 
				removeStudentFromClass();
		}

		private void mitExit_Click(object sender, System.EventArgs e)
		{
			checkForExit();
		}


		private void mitFTP_Click(object sender, System.EventArgs e)
		{
			string cmdArgs = "C:\\Program Files\\WS_FTP.exe"; // Application.StartupPath  + "\\pctoDelphi.fs";
			System.Console.WriteLine (cmdArgs);
            // System.Diagnostics.Process.Start(GlobalConstants.FTPString, cmdArgs);
            System.Diagnostics.Process.Start("C:\\Program Files\\WS_FTP\\ws_ftp95.exe", cmdArgs);
        }

		private void mitSaveToTextFile_Click(object sender, System.EventArgs e)
		{
			saveClassGradeToFile();
		}

		private void gbGradingPolicy_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void mitReadFile_Click(object sender, System.EventArgs e)
		{
			displayFileContents();
		}
		#endregion

		private void dgGrade_Navigate(object sender, System.Windows.Forms.NavigateEventArgs ne)
		{
		
		}

		private void mitHelp_Click(object sender, System.EventArgs e)
		{
		
		}

		private void txtStudentFilter_TextChanged(object sender, System.EventArgs e)
		{
		
		}
        private void addNewClass()
        {
            StringBuilder cid = new StringBuilder(""), year = new StringBuilder(""),
                          quarter = new StringBuilder(""), cname = new StringBuilder(""),
                          section = new StringBuilder("");
            new FrmNewClass(cid, year, quarter, cname, section).ShowDialog(this);
            String sCID = cid.ToString(), sYear = year.ToString(),
                sQuart = quarter.ToString(), sCName = cname.ToString(), sSec = section.ToString();

            int k;
            bool empty = sCID.Equals("") && sYear.Equals("") && sQuart.Equals("") &&
                sCName.Equals("") && sSec.Equals("");
            if (empty) return;

            bool someEmpty = sCID.Equals("") || sYear.Equals("") || sQuart.Equals("") ||
                sCName.Equals("") || sSec.Equals("");
            if (someEmpty)
            {
                MessageBox.Show("All fields must be filled!", "Incomplete New Class Info");
                return;
            }

            string msg = "Do you want to add the new class," + sCName + '/' + sQuart + ' ' + sYear + "(" +
                         sCID + "),\n and its default grading policy into database?";

            DialogResult ans = MessageBox.Show(null, msg, "Add New Class and Policy", MessageBoxButtons.YesNo);
            if (ans == DialogResult.Yes)
                k = TGradebookDB.addNewClassAndPolicy(sCID, sYear, sQuart, sCName, sSec);
        }

		private void mitAddClass_Click(object sender, System.EventArgs e)
		{
            addNewClass();
		}


		private void mitRemoveClass_Click(object sender, System.EventArgs e)
		{
			string msg = "Do you want to remove " + cmbCourseName.Text + "/" + cmbQuarter.Text + "/" + 
						cmbYear.Text + "\n(CID: " + GlobalConstsVars.CID + ", Instructor: " + 
						GlobalConstsVars.IName + ") and from the database ?";
			DialogResult ans = MessageBox.Show(null, msg, "Removal Course Confirmation", MessageBoxButtons.YesNo);
			if (ans == DialogResult.Yes ) 
			{
				int k = TGradebookDB.removeClassAndPolicy ();
				TGradebookDB.fillCourseNamesByYearQuarter(cmbYear.Text, cmbQuarter.Text, cmbCourseName);
			}
			return ;
		}



		private void dgStudent_MouseUp(object sender, MouseEventArgs e)
		{
			if ( e.Button == System.Windows.Forms.MouseButtons.Right  ) 
			{
				changStudentID();
			}
		}

		private void mitGradeReport_Click(object sender, System.EventArgs e)
		{
			//new FrmReport(ds).Show();
		}

		private void mitSaveGradesToTextFile_Click(object sender, System.EventArgs e)
		{
		
		}

		private void mitShowAllGrades_Click(object sender, System.EventArgs e)
		{
			string strResult = TGradebookDB.getAllGrades(dgStudent[dgStudent.CurrentRowIndex, 0].ToString());
			strResult = strResult == null? dgStudent[dgStudent.CurrentRowIndex, 1].ToString() + ", " +
				dgStudent[dgStudent.CurrentRowIndex, 2].ToString() + " has not taken any class from me yet!" : strResult;
			MessageBox.Show(this, strResult, "Grades for " + 
						dgStudent[dgStudent.CurrentRowIndex, 1].ToString() + ", " +
						dgStudent[dgStudent.CurrentRowIndex, 2].ToString());
		}

		private void cmbCourseName_SelectedIndexChanged_1(object sender, System.EventArgs e)
		{
		
		}

		private void txtMAXHWK_TextChanged(object sender, System.EventArgs e)
		{
		
		}


		private void lbChangeStatus_Click(object sender, System.EventArgs e)
		{
			changeStudentStatus();
		}

		private void mitChangeStudentID_Click(object sender, System.EventArgs e)
		{
			changStudentID();
		}

		private void FrmClassGrades_Closing(object sender, CancelEventArgs e)
		{
			checkForExit();
		}

		private void mitAddStudent_Click(object sender, System.EventArgs e)
		{
		
		}

		private void cmbQuarter_SelectedIndexChanged_1(object sender, System.EventArgs e)
		{
            cmbCourseName.Items.Clear();
            cmbCourseName.Text  = "";
            displayGradesInGrid();
		}

        private void lbMaxMidterm1_Click(object sender, EventArgs e)
        {

        }

        private void mitReloadData_Click(object sender, EventArgs e)
        {
            displayGradesInGrid();
        }

        private void gbStudentList_Enter(object sender, EventArgs e)
        {

        }

        private void dgStudent_Navigate(object sender, NavigateEventArgs ne)
        {

        }

        private void cmbMajors_SelectedIndexChanged(object sender, EventArgs e)
        {
            int curRow = dgStudent.CurrentRowIndex ;
            string mjr = cmbMajors.Text;

            string msg = "Change the major of " + dgStudent[curRow , 1]+ " " + dgStudent[curRow,2] + " to [" + cmbMajors.Text +"] ?"; 
            DialogResult ans = MessageBox.Show(null, msg, "Change Major Confirmation", MessageBoxButtons.YesNo);
            if (ans == DialogResult.Yes)
            {
                DataRow row = dtStudent.Rows.Find(dgStudent[dgStudent.CurrentRowIndex, 0]);
                row["MajorCode"] = int.Parse(cmbMajors.Text.Substring(12, 4));
            }
       }

        private void mitReport_Click(object sender, EventArgs e)
        {

        }

        private void mitClassTrack_Click(object sender, EventArgs e)
        {
            string fileName = GlobalConstsVars.cName + GlobalConstsVars.cQuarter + GlobalConstsVars.cYear +"Track.txt";
            Queue qTrack = null;
            qTrack = TGradebookDB.getClassTrack();
            if (qTrack == null || qTrack.Count < 1) return;

            StreamWriter file = new StreamWriter(fileName);
            file.WriteLine("===============================================================================================================");
            file.WriteLine( "CMPS " + GlobalConstsVars.cName.Substring(2) + ", " + GlobalConstsVars.cQuarter +
                " " + GlobalConstsVars.cYear + ", " + qTrack.Count + " students enrolled, by Huaqing");
            file.WriteLine("===============================================================================================================");
            while (qTrack.Count > 0 )  file.WriteLine ( qTrack.Dequeue() ) ;
            file.Close();
            System.Diagnostics.Process.Start("Notepad", fileName); 
        }

        private void mitClass_Click(object sender, EventArgs e)
        {

        }
	}  // end of class
} // end of namespace.
